Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2339 by niro, Fri Jan 3 14:20:42 2014 UTC revision 2416 by niro, Tue Jan 7 13:37:49 2014 UTC
# Line 9  Line 9 
9    
10  # ignore the environment  # ignore the environment
11  LC_ALL=C  LC_ALL=C
12    # include dir
13  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
14    
15  # configuration  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
16  if [ -e %SYSCONFDIR%/installer.conf ]  # -> now in images.conf
17  then  CURRENTLINE=0
18   source %SYSCONFDIR%/installer.conf  
19  else  die()
20   die "/etc/installer.conf not found"  {
21  fi   echo "Error: $@"
22     exit 1
23    }
24    
25  #images: (get ${CDIMAGENAME})  # load common includes
26    for inc in %SYSCONFDIR%/installer.conf \
27     ${INSTALLER_LIBDIR}/functions/common.sh \
28     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
31    do
32     if [ -e ${inc} ]
33     then
34     source "${inc}"
35     else
36     die "'${inc}' not found"
37     fi
38    done
39    
40    # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
41    # -> now in images.conf
42    CDIMAGENAME=""
43    TOTALLINES=""
44    CURRENTLINE=0
45  if [ -e /mnt/cdrom/system/images.conf ]  if [ -e /mnt/cdrom/system/images.conf ]
46  then  then
47   source /mnt/cdrom/system/images.conf   source /mnt/cdrom/system/images.conf
48     # check if all required variables are set
49     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
50     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
51  else  else
52   die "/mnt/cdrom/system/images.conf not found"   die "/mnt/cdrom/system/images.conf not found"
53  fi  fi
54    
 # includes  
 source ${INSTALLER_LIBDIR}/functions/hwdetection.sh  
   
55  ### System/Config Version  ### System/Config Version
56  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
57  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
58    
59  CDPATH="${DEFAULT_CDPATH}"  # some sane defaults
60  INSTALLPATH="${DEFAULT_INSTALLPATH}"  CDROOT="${DEFAULT_CDROOT}"
61    INSTALLROOT="${DEFAULT_INSTALLROOT}"
62  ### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1  KERNELPKG="${DEFAULT_KERNELPKG}"
63  CURRENTLINE=0  KERNELOPTS="${DEFAULT_KERNELOPTS}"
 #TOTALLINES=11072 # -> now in images.conf  
   
 # standard kernel opts  
 KERNELOPTS="quiet video=1024x768"  
   
 # grub options  
64  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
65  GRUB2OPTS=""  GRUB2OPTS=""
   
 # fdisk options  
66  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
   
 # default specialdevices  
67  SPECIALDEVICE=""  SPECIALDEVICE=""
68  FORMFACTOR="desktop"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
   
 # target filesystem  
69  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
70    
71  #################################################  #################################################
72  #  DIALOG BOXEN #  #  DIALOG BOXEN #
73  #################################################  #################################################
74    
75  die()  trap_exit()
76  {  {
77   echo "Error: $@"   is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
78     is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
79     is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
80     is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
81     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
82    
83     echo $"Installation aborted."
84   exit 1   exit 1
85  }  }
86    
87  dialog_die()  dialog_die()
88  {  {
89   ERROR=$1   ERROR="$1"
90   RETVAL=$?   RETVAL="$?"
91   dialog_install_failure   dialog_install_failure
92   exit 1   exit 1
93  }  }
94    
95  dialog_warning()  dialog_warning()
96  {  {
97   dialog \   local retval
98   --backtitle "${TITLE}" \  
99   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
100   --defaultno \   retval=$?
101   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
102   then   then
103   clear   clear
104   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
105   exit 1   exit 1
106   fi   fi
107  }  }
108    
109  dialog_setup_hdd_info()  dialog_setup_hdd_info()
110  {  {
111   local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
112    
113   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
114   --colors \   $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 1 Partition an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
115  }  }
116    
117  dialog_setup_hdd_info_auto()  dialog_setup_hdd_info_auto()
118  {  {
119   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
120    
121   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
122   --colors \   $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nAchtung!\n\  
  Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81  
123  }  }
124    
125  dialog_setup_system_menu()  dialog_setup_system_menu()
126  {  {
127   local i   local mode
128     local retval
129    
130   i=$(dialog \   mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \
131   --backtitle "${TITLE}" \   $"1:Automatic setup (recommended)" \
132   --title "[ Festplatten Partitionierung ]" \   ":" \
133   --cancel-label "Abbrechen" \   $":\Z1Expert modes:\Zn" \
134   --ok-label "Weiter" \   $"2:Common IDE-disk (manual setup)")
135   --stdout \   retval=$?
136   --colors \   [[ ${retval} -eq 1 ]] && return 1
137   --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \   if [[ ${retval} -eq 0 ]]
  "1" "Automatisches Setup (Empfohlen)" \  
  "" "" \  
  "" "\Z1Experten Modi:\Zn" \  
  "2" "Normale IDE-Disk (Manuell)" \  
  "3" "Flash-Speicher (Manuell)")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
138   then   then
139   case "${i}" in   case "${mode}" in
140   "1") run_install_auto ;;   "1") run_install_auto ;;
141           "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
142   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
143   esac   esac
144   fi   fi
# Line 173  dialog_hardware_detection() Line 149  dialog_hardware_detection()
149   local i   local i
150   local hwtmp   local hwtmp
151    
152   if [ -x $(which mktemp &> /dev/null) ]   if [ -x $(type -P mktemp) ]
153   then   then
154   hwtmp="$(mktemp)"   hwtmp="$(mktemp)"
155   else   else
156   hwtmp="/tmp/hwtmp.sh"   hwtmp="/tmp/hwtmp.sh"
157   fi   fi
158    
159   [[ ! -z ${installdevs} ]] && installdevs=""   run_hardware_detection_disks
160    
161   echo "dialog \\"  > ${hwtmp}   echo "dialog \\"  > ${hwtmp}
162   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}
# Line 190  dialog_hardware_detection() Line 166  dialog_hardware_detection()
166   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}
167   echo " Festplatten:\n \\" >> ${hwtmp}   echo " Festplatten:\n \\" >> ${hwtmp}
168    
169   if [[ ! -z ${scsidisks} ]]   if [[ ! -z ${ALL_DISKS} ]]
170   then   then
171   for i in ${scsidisks}   for i in ${ALL_DISKS}
172   do   do
173   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
174   done   done
175   fi   fi
176    
177   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
178   then   then
179   for i in ${idedisks}   echo " \n \\" >> ${hwtmp}
180     echo " CDROM Laufwerke:\n \\" >> ${hwtmp}
181     for i in ${ALL_CDROMS}
182   do   do
183   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
184   done   done
185   fi   fi
186    
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
  fi  
   
187   # other devices   # other devices
188   run_hardware_detection   run_hardware_detection
189   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
# Line 245  dialog_hardware_detection() Line 208  dialog_hardware_detection()
208   fi   fi
209  }  }
210    
211  dialog_setup_hdd_partitions_manuell()  dialog_setup_hdd_partitions_manual()
212  {  {
213   local i   local i
214    
# Line 278  dialog_setup_hdd_partitions_manuell() Line 241  dialog_setup_hdd_partitions_manuell()
241   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
242   then   then
243   dialog_setup_hdd_info   dialog_setup_hdd_info
244   setup_hdd_partitions_manuell   setup_hdd_partitions_manual
245   fi   fi
246   fi   fi
247  }  }
248    
249  dialog_setup_hdd_partitions_manuell_flash()  dialog_setup_hdd_partitions_auto()
250  {  {
251   local i   local i
252    
# Line 315  dialog_setup_hdd_partitions_manuell_flas Line 278  dialog_setup_hdd_partitions_manuell_flas
278   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
279   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
280   then   then
281   dialog_setup_hdd_info_flash   dialog_setup_hdd_info_auto
282   setup_hdd_partitions_manuell_flash   dialog_setup_hdd_create_partitions
283     setup_hdd_partitions_auto
284   fi   fi
285   fi   fi
286  }  }
287    
288  dialog_setup_hdd_partitions_auto()  run_hardware_detection_disks()
289  {  {
290   local i   local bootdev
291    
292   if [[ -z ${installdevs} ]]   # all disks but exclude ramdisks
293     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
294     # remove the boot device from ALL_DISKS if it was an usbstick
295     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
296   then   then
297   dialog \   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
298   --backtitle "${TITLE}" \   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
299   fi   fi
300     export ALL_CDROMS="$(get_hwinfo cdrom)"
301  }  }
302    
303  dialog_setup_hdd_create_partitions()  dialog_setup_hdd_create_partitions()
# Line 448  dialog_main() Line 388  dialog_main()
388   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
389   then   then
390   case ${METHOD} in   case ${METHOD} in
391           "1") dialog_setup_system_menu ;;   "1") dialog_setup_system_menu ;;
392   "2") dialog_hardware_detection ;;   "2") dialog_hardware_detection ;;
393   "3") install_do_reboot ;;   "3") install_do_reboot ;;
394   "4") /bin/bash --login -i ;;   "4") /bin/bash --login -i ;;
# Line 597  EOF Line 537  EOF
537   fi   fi
538  }  }
539    
540  setup_hdd_partitions_manuell()  setup_hdd_partitions_manual()
 {  
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || dialog_die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
541  {  {
542   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
543    
544   ## hdds partitionieren manuell   ## hdds partitionieren manual
545   cfdisk ${HDD} || dialog_die   cfdisk ${HDD} || dialog_die
546  }  }
547    
548  setup_hdd_format()  setup_hdd_format()
549  {  {
  mkswap ${SWAPHDD} || dialog_die  
  mke2fs -j -q ${BOOTHDD} || dialog_die  
  mke2fs -j -q ${ROOTHDD} || dialog_die  
 }  
   
 setup_hdd_format_flash()  
 {  
550   mke2fs -j -q ${ROOTHDD} || dialog_die   mke2fs -j -q ${ROOTHDD} || dialog_die
551  }  }
552    
553  install_mount_rootfs()  install_mount_rootfs()
554  {  {
555   swapon ${SWAPHDD} || dialog_die   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die
556   mount ${ROOTHDD} ${INSTALLPATH} || dialog_die   install -d ${INSTALLROOT}/boot || dialog_die
557   install -d ${INSTALLPATH}/boot || dialog_die   cd ${INSTALLROOT} || dialog_die
  mount ${BOOTHDD} ${INSTALLPATH}/boot || dialog_die  
  cd ${INSTALLPATH} || dialog_die  
 }  
   
 install_mount_rootfs_flash()  
 {  
  mount ${ROOTHDD} ${INSTALLPATH} || dialog_die  
  install -d ${INSTALLPATH}/boot || dialog_die  
  cd ${INSTALLPATH} || dialog_die  
558  }  }
559    
560  install_system_image()  install_system_image()
561  {  {
562   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
563  }  }
564    
565  install_bootsector_chroot()  install_bootsector_chroot()
566  {  {
567   local my_roothdd   local my_roothdd
568   local grubconf=${INSTALLPATH}/boot/grub/grub.conf   local grubconf=${INSTALLROOT}/boot/grub/grub.conf
569   local grub2conf=/boot/grub/grub.cfg   local grub2conf=/boot/grub/grub.cfg
570    
571   # check for grub2   # check for grub2
572   if [[ -f ${INSTALLPATH}/sbin/grub-mkconfig ]]   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
573   then   then
574   # needed by grub-mkconfig on the first run   # needed by grub-mkconfig on the first run
575   if [[ ! -f ${INSTALLPATH}/boot/grub/video.lst ]]   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
576   then   then
577   install -m0644 ${INSTALLPATH}/lib/grub/*/video.lst ${INSTALLPATH}/boot/grub/video.lst || dialog_die   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
578   fi   fi
579    
580   # set kernelopts   # set kernelopts
581   if [[ -f ${INSTALLPATH}/etc/conf.d/grub ]]   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
582   then   then
583   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLPATH}/etc/conf.d/grub || dialog_die   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
584   else   else
585   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLPATH}/etc/conf.d/grub || dialog_die   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die
586   fi   fi
587   echo 'grub-mkdevicemap' > ${INSTALLPATH}/root/.installrc || dialog_die   echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die
588   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLPATH}/root/.installrc || dialog_die   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
589   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLPATH}/root/.installrc || dialog_die   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
590   echo "exit 0" >> ${INSTALLPATH}/root/.installrc || dialog_die   echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die
591    
592   # grub-legacy   # grub-legacy
593   else   else
594   ### grubconf schreiben   ### grubconf schreiben
595   source ${INSTALLPATH}/boot/kernelversion   source ${INSTALLROOT}/boot/kernelversion
596    
597   #for alx only   #for alx only
598   if [ -e ${INSTALLPATH}/etc/alx_version ]   if [ -e ${INSTALLROOT}/etc/alx_version ]
599   then   then
600   OLD_ALXVER="${ALXVER}"   OLD_ALXVER="${ALXVER}"
601   source ${INSTALLPATH}/etc/alx_version   source ${INSTALLROOT}/etc/alx_version
602   KRNVER="ALX-${ALXVER}"   KRNVER="ALX-${ALXVER}"
603   ALXVER="${OLD_ALXVER}"   ALXVER="${OLD_ALXVER}"
604   fi   fi
# Line 705  install_bootsector_chroot() Line 619  install_bootsector_chroot()
619   echo "default 0" >> ${grubconf} || dialog_die   echo "default 0" >> ${grubconf} || dialog_die
620   echo "timeout 3" >> ${grubconf} || dialog_die   echo "timeout 3" >> ${grubconf} || dialog_die
621   # using current root password   # using current root password
622   echo "password --md5 $(cat ${INSTALLPATH}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die   echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die
623    
624   echo  >> ${grubconf} || dialog_die   echo  >> ${grubconf} || dialog_die
625   echo "# normal boot" >> ${grubconf} || dialog_die   echo "# normal boot" >> ${grubconf} || dialog_die
# Line 739  install_bootsector_chroot() Line 653  install_bootsector_chroot()
653   fi   fi
654    
655   # bootsector schreiben chrooted schreiben (lfs/magellan)   # bootsector schreiben chrooted schreiben (lfs/magellan)
656   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
657  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
658  root (hd0,0)  root (hd0,0)
659  setup (hd0)  setup (hd0)
# Line 750  CHROOTEOF Line 664  CHROOTEOF
664   fi   fi
665    
666   ## enter chroot   ## enter chroot
667   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
668   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
669   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
670   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
671   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
672   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
673   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
674   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
675  }  }
676    
677  is_initrd_supported()  is_initrd_supported()
678  {  {
679   # only generate initrds if the cmd exists   # only generate initrds if the cmd exists
680   [[ -x ${INSTALLPATH}/sbin/mkinitrd ]] && return 0   [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0
681   return 1   return 1
682  }  }
683    
# Line 794  install_initrd_chroot() Line 708  install_initrd_chroot()
708   fi   fi
709    
710   # install an appropriate uvesafb.conf   # install an appropriate uvesafb.conf
711   install -d ${INSTALLPATH}/etc/modprobe.d || dialog_die   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
712   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLPATH}/etc/modprobe.d/uvesafb.conf || dialog_die   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die
713    
714   # install an appropriate viafb.conf   # install an appropriate viafb.conf
715   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLPATH}/etc/modprobe.d/viafb.conf || dialog_die   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die
716    
717   # install an appropriate i810fb.conf   # install an appropriate i810fb.conf
718   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLPATH}/etc/modprobe.d/i810fb.conf || dialog_die   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die
719    
720   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
721  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
722  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
723  exit 0  exit 0
724  CHROOTEOF  CHROOTEOF
725    
726   ## enters chroot   ## enters chroot
727   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
728   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
729   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
730   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
731   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
732   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
733   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
734   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
735  }  }
736    
737  is_uuid_supported()  is_uuid_supported()
738  {  {
739   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   if [[ -x $(type -P busybox.mkinitrd) ]]
740   then   then
741   # only detect uuids if supported   # only detect uuids if supported
742   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
# Line 858  install_system_settings() Line 772  install_system_settings()
772   # schreibe fstab   # schreibe fstab
773   if is_uuid_supported   if is_uuid_supported
774   then   then
775   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || dialog_die   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || dialog_die  
776   else   else
777   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || dialog_die   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || dialog_die  
778   fi   fi
779   # not needed busybox loads all with swapon -a, even if not mentioned in fstab   # not needed busybox loads all with swapon -a, even if not mentioned in fstab
780   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || dialog_die   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
781   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || dialog_die   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
782   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || dialog_die   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
783    
784   # install network config skeleton   # install network config skeleton
785   install -m0644 ${INSTALLPATH}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLPATH}/etc/conf.d/ || dialog_die   install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die
786    
787   # intel framebufer quirk   # intel framebufer quirk
788   if [[ -e /proc/fb ]]   if [[ -e /proc/fb ]]
# Line 880  install_system_settings() Line 792  install_system_settings()
792   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
793   if [[ ${fbdev} != 0 ]]   if [[ ${fbdev} != 0 ]]
794   then   then
795   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLPATH}/etc/splash/splash.conf || dialog_die   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
796   fi   fi
797   fi   fi
798   fi   fi
799  }  }
800    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || dialog_die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || dialog_die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || dialog_die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || dialog_die  
 }  
   
801  install_umount_rootfs()  install_umount_rootfs()
802  {  {
803   cd /   cd /
804   umount ${INSTALLPATH}/boot || dialog_die   umount ${INSTALLROOT}/boot || dialog_die
805   umount ${INSTALLPATH} || dialog_die   umount ${INSTALLROOT} || dialog_die
  swapoff ${SWAPHDD} || dialog_die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLPATH} || dialog_die  
806  }  }
807    
808  install_do_reboot()  install_do_reboot()
# Line 926  run_install_normal() Line 818  run_install_normal()
818  {  {
819   dialog_hardware_detection   dialog_hardware_detection
820    
821   dialog_setup_hdd_partitions_manuell   dialog_setup_hdd_partitions_manual
822   dialog_setup_hdd_format   dialog_setup_hdd_format
823   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
824   install_mount_rootfs   install_mount_rootfs
# Line 944  run_install_normal() Line 836  run_install_normal()
836   dialog_install_successful   dialog_install_successful
837  }  }
838    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
839  run_install_auto()  run_install_auto()
840  {  {
841   dialog_hardware_detection   dialog_hardware_detection
842    
843   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
844   dialog_setup_hdd_format   dialog_setup_hdd_format
845   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
846   install_mount_rootfs_flash   install_mount_rootfs
847   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image
848    
849   dialog_install_settings   dialog_install_settings
850   sleep 1   sleep 1
851   install_system_settings_flash   install_system_settings
852   install_initrd_chroot   install_initrd_chroot
853    
854   dialog_install_bootsector   dialog_install_bootsector
855   install_bootsector_chroot   install_bootsector_chroot
856    
857   install_umount_rootfs_flash   install_umount_rootfs
858   dialog_install_successful   dialog_install_successful
859  }  }
860    
861    # set some proper traps
862    trap "trap_exit" SIGINT SIGQUIT
863    
864  dialog_main  dialog_main
865    
866  exit 0  exit 0

Legend:
Removed from v.2339  
changed lines
  Added in v.2416